﻿Imports System.IO

Public Class frmTreeviewFromFile
   Private _FileListData As New FileInfo("..\..\File.txt")

   Public Sub New()
      InitializeComponent()
   End Sub
   
   Private Sub btLoadFileList_Click(sender As Object, e As EventArgs) Handles btLoadFile.Click
      TreeView1.BeginUpdate()
      TreeView1.Nodes.Clear()
      For Each line In File.ReadAllLines(_FileListData.FullName)
         With TreeView1.Nodes.Approach(line.Split("\"c))
            .InsertRest()
         End With
      Next
      TreeView1.ExpandAll()
      TreeView1.EndUpdate()
      'MessageBox.Show("Nodes total: " & CountChildNodes(TreeView1.Nodes))
      'MessageBox.Show("Nodes total: " & TreeView1.GetNodeCount(True))
   End Sub

   Private Function CountChildNodes(nodes As TreeNodeCollection) As Integer
      Dim cnt = 0
      Dim recurse As Action(Of TreeNodeCollection) = Sub(nds)
                                                        cnt += nds.Count
                                                        For Each nd As TreeNode In nds
                                                           recurse(nd.Nodes)
                                                        Next
                                                     End Sub
      recurse(nodes)
      Return cnt
   End Function

   Private Sub btRewriteFile_Click(sender As Object, e As EventArgs) Handles btRewriteFile.Click
      Using wri = New StreamWriter(_FileListData.OpenWrite)
         For Each di In New DirectoryInfo("..\..\..").GetFiles("*.*", SearchOption.AllDirectories)
            wri.WriteLine(di.FullName)
         Next
      End Using
   End Sub

   Private Sub btCountChildNodes_Click(sender As Object, e As EventArgs) Handles btCountChildNodes.Click
      MessageBox.Show(TreeView1.SelectedNode.FullPath & Lf & "ChildNodes total = " & CountChildNodes(TreeView1.SelectedNode.Nodes))
   End Sub

   Private Sub btSave_Click(sender As Object, e As EventArgs) Handles btSave.Click
      Using wri = New StreamWriter(_FileListData.OpenWrite)
         Dim recurse As Action(Of TreeNodeCollection) = Sub(nds)
                                                           For Each nd As TreeNode In nds
                                                              wri.WriteLine(nd.FullPath)
                                                              recurse(nd.Nodes)
                                                           Next
                                                        End Sub
         recurse(TreeView1.Nodes)
      End Using
   End Sub
End Class
